#include "CCollisionVisitor.h"

#include "GameIncludes.h"

CCollisionVisitor::CCollisionVisitor(CNode* movingNode, const Vector2f move) : 
_movingNode(movingNode),
_move(move),
_bCollide(false),
_colliderNode(nullptr)
{
	_movingSprite = dynamic_cast<sf::Sprite*>(_movingNode->getDrawable());
}


CCollisionVisitor::~CCollisionVisitor(void)
{
}

void CCollisionVisitor::visit( CNode* node )
{
	if (!_movingSprite || _bCollide)
		return;

	CNodeVisitor::visit(node);

	sf::Sprite* spriteToCheck = dynamic_cast<sf::Sprite*>(node->getDrawable());
	if (!spriteToCheck || _movingSprite == spriteToCheck)
		return;

	_bCollide = Collision::BoundingBoxTest(*_movingSprite, *spriteToCheck, _MTV);
	if (_bCollide)
	{
		_colliderNode = node;
		//make the MTV is well oriented
		_MTV.x = _move.x > 0 ? -std::abs(_MTV.x) : std::abs(_MTV.x);
		_MTV.y = _move.y > 0 ? -std::abs(_MTV.y) : std::abs(_MTV.y);
	}
}
