#pragma once

#include "stdafx.h"

#include "CRecorder.h"

class CLevel;
class CNode;

class CGame
{
public:
	static CGame* getInstance();

public:
	CGame(void);
	~CGame(void);

	void run();

	void startGame();

	float getGameTime() { return _gameTime; }
	float getDeltaTime() { return _frameClock.getElapsedTime().asSeconds(); }

	void validateMove( CNode* Node, Vector2f& Offset );
	void notifyDeath( CNode* Node );

	//Score
	int getScore() const { return _score; }
	void addScore(int score) { _score += score; };

	float getReverseCoeff() const { return _reverseCoeff; };

	void spawnNode(CNode* spawnedNode);
	void deleteNode(CNode* deletedNode);

	void togglePause();

	CDifficultyParams getActualDifficultyParams();

private:
	void updatePass( CLevel* level, float simulationTime );
	void drawPass(sf::RenderTarget& renderTarget, CLevel* level );
	void definitelyDestroyNode( CNode* Object );
	void addToScene( CNode* node );
	void stopGame();
private:
	std::multimap<float, CNode*>		_spawnedNodes;
	std::multimap<float, CNode*>		_deletedNodes;

	Clock								_frameClock;
	float								_gameTime;
	bool								_gameStarted;

	CLevel*								_currentLevel;
	CLevel*								_mainMenuLevel;
	CLevel*								_endMenuLevel;
	CLevel*								_hudLevel;
	CLevel*								_pauseMenuLevel;

	int									_score;
	float								_reverseCoeff;
	bool								_bPause;

	Vector2i							_screenSize;
	
};

