#include "CMath.h"

CMath::CMath(void)
{
}


CMath::~CMath(void)
{
}

void CMath::Normalize( Vector2f& move )
{
	float size = Size(move);
	if (size > 0.0001f)
	{
		move.x /= size;
		move.y /= size;
	}
}

float CMath::Size( const Vector2f& move )
{
	return sqrt(move.x * move.x + move.y * move.y);
}

float CMath::SizeSquared( const Vector2f& move )
{
	return (move.x * move.x + move.y * move.y);
}

float CMath::GetAngleBetweenAxis( const Vector2f& axis1, const Vector2f& axis2 )
{
	return ToDegrees( atan2( axis2.y, axis2.x ) - atan2(axis1.y, axis1.x ) );
}

float CMath::ToDegrees( float radians )
{
	return radians * DEGREES_PER_RADIAN;
}

float CMath::ToRadians( float degrees )
{
	return degrees * RADIANS_PER_DEGREE;
}

Vector2f CMath::GetNormalized( const Vector2f&  vector)
{
	Vector2f result = vector;
	CMath::Normalize(result);
	return result;
}
