#pragma once

#include "stdafx.h"

#define PI 3.14159265359f
#define DEGREES_PER_RADIAN 180.0f / PI
#define RADIANS_PER_DEGREE PI / 180.0f

class CMath
{
public:
	CMath(void);
	~CMath(void);

	template<class T>
	static T Blend(T Left, T Right, float Coeff)
	{
		return Left * (1.0f - Coeff) + Right * Coeff;
	}

	template<class T>
	static T Clamp(T Value, T Min, T Max)
	{
		if (Value < Min)
			return Min;
		if (Value > Max)
			return Max;
		return Value;
	}

	static void Normalize( Vector2f& move );
	static float Size(const Vector2f& move);
	static float SizeSquared(const Vector2f& move);
	static float GetAngleBetweenAxis(const Vector2f& axis1, const Vector2f& axis2);
	static float ToDegrees( float radians );
	static float ToRadians( float degrees );
	static Vector2f GetNormalized( const Vector2f& vector );
};

