#include "CMovingBehavior.h"

#include "GameIncludes.h"

CMovingBehavior::CMovingBehavior(void)
{
}


CMovingBehavior::~CMovingBehavior(void)
{
}

void CMovingBehavior::update( CNode* Owner, float DeltaTime )
{
	CNodeBehavior::update(Owner, DeltaTime);

	if (DeltaTime > 0.0f)
	{
		//update position
		Vector2f Offset;
		Offset.x = -_direction.x;
		Offset.y = -_direction.y;
		Offset *= _speed * DeltaTime;

		Owner->move(Offset);

		//set rotation to the direction
		Owner->setXVector(_direction);
	}
	else if (CRecorder::getInstance()->isRecordingObject(Owner))
	{
		CRecorder::getInstance()->replayRecordedObject(Owner);
	}
}
