#include "CPlayerControllerBH.h"

#include "GameIncludes.h"


CPlayerControllerBH::CPlayerControllerBH(void)
{
}


CPlayerControllerBH::~CPlayerControllerBH(void)
{
}

void CPlayerControllerBH::update( CNode* Owner, float DeltaTime )
{
	CNodeBehavior::update(Owner, DeltaTime);

	if (DeltaTime > 0.0f)
	{
		CDifficultyParams Params = CGame::getInstance()->getActualDifficultyParams();

		Vector2f move;
		float rotation = 0.0f;
		float upDown = 0.0f;

		if (Keyboard::isKeyPressed(Keyboard::Left))
		{
			rotation -= 1.0f;
		}
		if (Keyboard::isKeyPressed(Keyboard::Up))
		{
			upDown -= 1.0f;
		}
		if (Keyboard::isKeyPressed(Keyboard::Right))
		{
			rotation += 1.0f;
		}
		if (Keyboard::isKeyPressed(Keyboard::Down))
		{
			upDown += 1.0f;
		}
		
		if ((Keyboard::isKeyPressed(Keyboard::RControl) || Keyboard::isKeyPressed(Keyboard::LControl)) && _shootCooldown <= 0.0f)
		{
			Owner->shoot();
			_shootCooldown = Params._fireInterval;
		}
		_shootCooldown -= DeltaTime;

		if (!CRecorder::getInstance()->isRecordingObject(Owner))
		{
			CRecorder::getInstance()->addRecordingObject(Owner);
		}

		rotation *= Params._rotationSpeed * DeltaTime; 
		Owner->rotate(rotation);

		Vector2f dir = Owner->getXVector();
		Owner->_velocity += dir * Params._moveSpeed * DeltaTime *upDown;

		if (CMath::SizeSquared(Owner->_velocity) > Params._moveSpeed * Params._moveSpeed)
		{
			Owner->_velocity = CMath::GetNormalized(Owner->_velocity) * Params._moveSpeed;
		}
		
		Owner->move(Owner->_velocity * DeltaTime);

		_shootCooldown -= DeltaTime;
	}
	else if (CRecorder::getInstance()->isRecordingObject(Owner))
	{
		CRecorder::getInstance()->replayRecordedObject(Owner);
	}
}
