#include "CProfiler.h"

#include "GameIncludes.h"

CScopeProfiler::CScopeProfiler(const std::string& name) :
_name(name)
{
	_clock.restart();
}


CScopeProfiler::~CScopeProfiler(void)
{
	CProfiler::getInstance()->registerProfilerTime(_name, _clock.getElapsedTime().asSeconds());
}

CProfiler* CProfiler::getInstance()
{
	static CProfiler instance;
	return &instance;
}

void CProfiler::registerProfilerTime( const std::string& name, float milliSeconds )
{
	_profilerTimes[name] = milliSeconds;
	auto text = _profilerText[name];
	if (!text)
	{
		text = new Text(name, *CSerializer::getInstance()->getDefaultFont(), 10);
		_profilerText[name] = text;
	}
	std::stringstream stream;
	stream << name << " : " << milliSeconds;
	text->setString(stream.str());
}

void CProfiler::update( float DeltaTime, sf::RenderTarget* RenderTarget )
{
	Vector2f position;
	for (auto ItText = _profilerText.begin(); ItText != _profilerText.end(); ++ItText)
	{
		ItText->second->setPosition(position);
		RenderTarget->draw(*ItText->second);
		position.y += ItText->second->getCharacterSize();
	}
}
