#pragma once

#include "stdafx.h"

class CNode;
class CLevel;

class CSerializer
{
public:
	static const std::string LevelSceneName;
	static const std::string SpriteName;
	static const std::string GroupName;
	static const std::string TextName;

public:
	CSerializer(void);
	~CSerializer(void);

	static CSerializer* getInstance();

	void addNodeBehaviors(const tinyxml2::XMLElement& Element, CNode* node);
	void parseTransformableElement(const tinyxml2::XMLElement& Element, sf::Transformable* Transformable);
	CNode* loadFromXml(const tinyxml2::XMLElement& Element);
	CNode* loadFromXmlFile(const std::string& file);


	sf::Sprite* createSprite( const tinyxml2::XMLElement& Element );
	sf::Text* createText(const tinyxml2::XMLElement& Element);

	CNode* getCopyOf(const CNode* originalNode);

	CLevel* loadLevelFromXmlFile(const std::string& path);

	const tinyxml2::XMLElement* FindDeepFirstChildElement(const tinyxml2::XMLElement* Parent, const std::string& name);

	const sf::Font* getDefaultFont() const { return _defaultFont; }

private:
	sf::Font*		_defaultFont;
};

